@echo off
rem ######################################################################
::
::	Putzi4win-Plugin - Helper for Gecko based webbrowsers
::
::	this script lists cache, Cookies, history file(s) of Gecko based
::	webbrowsers like Firefox, Netscape, Flock etc.
::
::	syntax:
::	gecko_data.bat [browserdir] [type]
::		browserdir is relative dir below %APPDATA%
::		type is one of cache, cookies, history
rem ----------------------------------------------------------------------
::	2007-03-24   support@putzi4win.de
rem ######################################################################

rem ----------------------------------------------------------------------
::	CONFIG
rem ----------------------------------------------------------------------

	set commentLine=# -----------------------------------------------------------------------------
	set lineA=# =============================================================================
	set regValue=HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData

	echo %lineA%
	echo #
	echo # START GECKO TOOLS
	echo #
	echo # geckodir : %%APPDATA%%\%1
	echo # type     : %2
	echo #
	echo %lineA%


	if NOT "%1"=="" goto test2
	echo ERROR:%0 wurde nicht korrekt aufgerufen. Der erste Parameter fehlt.
	exit
	
	:test2
	if NOT "%2"=="" goto start
	echo ERROR:%0 wurde nicht korrekt aufgerufen. Der zweite Parameter fehlt.
	exit
	
	
rem ----------------------------------------------------------------------
::
::	SHOW DATA
::
rem ----------------------------------------------------------------------

	:start
	set geckoDir=%1

	if EXIST "%APPDATA%\%geckoDir%\profiles.ini" goto step2
	echo ERROR:Es wurde keine profiles.ini unter %%APPDATA%%\%geckoDir% gefunden. Dieser Webbrowser ist wohl nicht installiert.
	exit
	
	
	:step2
	if "%2"=="cookies" set datfile=cookies.txt
	if "%2"=="history" set datfile=history.dat

	set DataDir1=%APPDATA%\%geckoDir%
	set DataDir2=
	set PATH=%PATH%;%~0\..\

	For /F "tokens=2* delims==" %%i in ('shregv "%regValue%" ^| findstr "="' ) Do set DataDir2=%%i
	if exist "%DataDir2%" set DataDir2=%DataDir2%\%geckoDir%

	for /F "tokens=2 delims==" %%a in ('type "%APPDATA%\%geckoDir%\profiles.ini" ^| findstr /i "^Path="') do (
	
		echo %commentLine%
		echo # files of profile %%a
		echo %commentLine%
		
		if "%2"=="cache" (
			if exist "%%a\cache\" for /F "tokens=*" /F %%b in ('dir /a:-D /s /b "%%a\cache\"') do echo FILE:%%b
			if exist "%DataDir1%\%%a\cache\" for /F "tokens=*" /F %%b in ('dir /a:-D /s /b "%DataDir1%\%%a\cache\"') do echo FILE:%%b
			if exist "%DataDir2%\%%a\cache\" for /F "tokens=*" /F %%b in ('dir /a:-D /s /b "%DataDir2%\%%a\cache\"') do echo FILE:%%b
		)
		if "%2"=="cookies" (
			if exist "%%a\%datfile%" echo FILE:%%a\%datfile%
			if exist "%DataDir1%\%%a\" echo FILE:%DataDir1%\%%a\%datfile%
			if exist "%DataDir2%\%%a\" echo FILE:%DataDir2%\%%a\%datfile%
		)
		if "%2"=="history" (
			if exist "%%a\%datfile%" echo FILE:%%a\%datfile%
			if exist "%DataDir1%\%%a\" echo FILE:%DataDir1%\%%a\%datfile%
			if exist "%DataDir2%\%%a\" echo FILE:%DataDir2%\%%a\%datfile%
		)
	)

	echo #
	echo # END OF GECKO_TOOLS
	echo #

	goto end


rem ----------------------------------------------------------------------
::	END
rem ----------------------------------------------------------------------

	:end


rem ----------------------------------------------------------------------
::	EOF
rem ----------------------------------------------------------------------
