@echo off
rem ======================================================================
::
::	list files - addon for the plugins
::	this script lists a given directory
::
::  syntax:
::  list_files directory [filefilter] [age_in_days] [0|1] [0|1] [0|1] [0|1]
::                                                   ^     ^     ^    ^
::                                                   |     |     |    show empty dirs
::                                                   |     |     attHidden
::                                                   |     attReadonly
::                                                   recursive scan
::
rem ----------------------------------------------------------------------
::	2006-10-29  v1.0  ah
rem ======================================================================

rem ----------------------------------------------------------------------
::	configuration
rem ----------------------------------------------------------------------

	set sDir=%~1
	::set sDir=c:\temp
	set sFilter=%~2
	set iDays=%~3
	::set iDays=10
	set bRecursive=%~4
	set bAttHidden=%~5
	set bAttSystem=%~6
	set bEmptyDirs=%~7

	set lineA=# =============================================================================
	
rem ----------------------------------------------------------------------
::	check variables
rem ----------------------------------------------------------------------
	if "%sDir%"=="" echo ERROR: Es wurde kein Verzeichnis angegeben. && goto end
	if "%sFilter%"=="" set sFilter=*.*
	if "%iDays%"=="" set iDays=0

	::set sParams=/includeRO /includeH /recurse
	set sParams=
	if "%bRecursive%"=="1" set sParams=%sParams% /recurse
	if "%bAttHidden%"=="1" set sParams=%sParams% /includeH
	if "%bAttSystem%"=="1" set sParams=%sParams% /includeRO

rem ----------------------------------------------------------------------
::	MAIN
rem ----------------------------------------------------------------------

	echo %lineA%
	echo #
	echo # START file lister
	echo #
	echo # dir   : %sDir%
	echo # filter: %sFilter%
	echo # age   : %iDays% day^(s^)
	echo # params: %sParams%
	echo #
	echo %lineA%

	set cmdFilesA=delage32 "%sDir%\%sFilter%" %iDays% /preview %sParams% 
	set cmdDirsA=delage32 "%sDir%\%sFilter%" %iDays% /preview /rd %sParams% 

	echo #
	echo # list files: 
	echo # %cmdFilesA%
	echo #
	for /F "tokens=1*" /F %%a in ('%cmdFilesA% ^| sort') do echo FILE:%sDir%\%%b

	if %bEmptyDirs%==0 goto end

	echo #
	echo # list dirs : 
	echo # %cmdDirsA%
	echo #
	for /F "tokens=1*" /F %%a in ('%cmdDirsA% ^| sort /r ^| findstr "\(rd\)"') do call :showdirname "%sDir%\%%b"

	goto end

	:showdirname
	set line=%~1
	echo DIR:%line:~0,-5%
	goto end2

rem ----------------------------------------------------------------------
::	END
rem ----------------------------------------------------------------------

	:end
	echo #
	echo # END file lister
	echo #
	echo %lineA%
	:: pause && exit

	:end2

rem ----------------------------------------------------------------------
::	EOF
rem ----------------------------------------------------------------------
