@echo off
rem ######################################################################
::
::	Putzi4win-Plugin - Helper
::
rem ----------------------------------------------------------------------
::
::	all keys from ...\CurrentVersion\Explorer\Shell Folders\
::	will be put to a variable DIR_[Value]
::	(spaces in the value are replaced with "_")
::
::	to get your values write in your bat-plugin:
::	call "%~dp0\tools\set_dirs.bat" [Filter]
::
::	Without filter variables from all registry values will be set. 
::	The filter is optional. It searches in Registryvalues. It is
::	not case sensitive.
::	You should use a filter because this is faster.
::
::	examples for using a filter:
::	call "%~dp0\tools\set_dirs.bat" Desk
::	or
::	call "%~dp0\tools\set_dirs.bat" top
::	... will find the Desktop entry and sets the variable DIR_Desktop
::
::	call "%~dp0\tools\set_dirs.bat" start
::	... matches the Start menu and the startup folder and sets
::	    DIR_Startup and DIR_Start_Menu
::
rem ----------------------------------------------------------------------
::	2007-03-24   support@putzi4win.de  v1.0
::	2007-04-02   support@putzi4win.de  v1.1  added optional filter
rem ######################################################################

rem ----------------------------------------------------------------------
::	CONFIG
rem ----------------------------------------------------------------------

	set lineA=# =============================================================================
	set regKey=HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\
	set PATH=%PATH%;%~0\..\
	
	set filter=%~1

rem ----------------------------------------------------------------------
::	MAIN
rem ----------------------------------------------------------------------
	echo %lineA%
	echo #
	echo # START SET DIRS
	echo #
	echo # setting values of directories from registry key
	echo # %regKey%
	if NOT "%filter%"=="" echo # filter: %filter% && echo #
	echo #

	For /F "tokens=1,2* delims==" %%i in ('shregv "%regKey%" ^| findstr /i "%filter%.*\[.*=" ' ) Do (
		call :setvar '%%i' "%%j"
	)
	goto end
	
rem ----------------------------------------------------------------------
::	SUBS
rem ----------------------------------------------------------------------
	:setvar
	set myvar='%~1'
	set myvalue=%~2
	
	set myvar=%myvar:'=%
	set myvar=%myvar:"=%
	set myvar=%myvar: =_%
	set myvar=DIR_%myvar%
	
	For /F "tokens=1 delims=[" %%i in ('echo %myvar%') Do (
		set %%i=%myvalue%
		echo # %%i=%myvalue%
	)
	goto end2
	

rem ----------------------------------------------------------------------
::	END
rem ----------------------------------------------------------------------
	:end
	echo #
	echo # ... I hope you can use one or some ;-)
	echo #
	:end2

rem ----------------------------------------------------------------------
::	EOF
rem ----------------------------------------------------------------------
